VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmRemoteMachineInfo 
   Caption         =   "Remote Machine Information"
   ClientHeight    =   5670
   ClientLeft      =   1560
   ClientTop       =   2445
   ClientWidth     =   8850
   Icon            =   "RemoteMachineInfo.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5670
   ScaleWidth      =   8850
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   5010
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   405
      Left            =   3630
      TabIndex        =   9
      Top             =   5160
      Width           =   1155
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "&Print"
      Height          =   405
      Left            =   2370
      TabIndex        =   8
      Top             =   5160
      Width           =   1155
   End
   Begin VB.ListBox lstMachineInfo 
      Height          =   4740
      Left            =   2370
      TabIndex        =   6
      Top             =   300
      Width           =   6435
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   405
      Left            =   7650
      TabIndex        =   3
      Top             =   5160
      Width           =   1155
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "&Execute"
      Height          =   405
      Left            =   540
      TabIndex        =   2
      Top             =   3510
      Width           =   1155
   End
   Begin VB.ListBox lstComputers 
      Height          =   2205
      Left            =   60
      TabIndex        =   0
      Top             =   840
      Width           =   2145
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Machine Information:"
      Height          =   195
      Index           =   0
      Left            =   2370
      TabIndex        =   7
      Top             =   60
      Width           =   1485
   End
   Begin VB.Label lblLogonDomain 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   30
      TabIndex        =   5
      Top             =   300
      Width           =   2235
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Logon Domain:"
      Height          =   195
      Index           =   5
      Left            =   30
      TabIndex        =   4
      Top             =   60
      Width           =   1080
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Computers:"
      Height          =   195
      Index           =   1
      Left            =   60
      TabIndex        =   1
      Top             =   630
      Width           =   795
   End
End
Attribute VB_Name = "frmRemoteMachineInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_objApiClass                  As clsAPI
Private m_astrDescriptions()           As String
Private m_strLocalMachineName          As String

Private Sub cmdExit_Click()
   Unload Me
End Sub

Private Sub cmdExecute_Click()
On Error GoTo ErrTrap
   Dim p_strComputerName               As String
   Dim p_objWbemRoot                   As SWbemServices
   Dim p_colComputers                  As SWbemObjectSet
   Dim p_objComputer                   As SWbemObject
   Dim p_lngIndex                      As Long
   Dim p_lngLoop                       As Long
   Dim p_strText1                      As String
   Dim p_strText2                      As String
   Dim p_strText3                      As String
   Dim p_lngRtn                        As Long
   Dim p_strName                       As String
   Dim p_strComments                   As String
   Dim p_vntRtn                        As Variant
   Dim p_objWmiInfo                    As cWmiInfo
   
   Me.lstMachineInfo.Clear
   
   p_strComputerName = Me.lstComputers.List(Me.lstComputers.ListIndex)
   
   If p_strComputerName = "[Local Computer]" Then
      p_strComputerName = m_strLocalMachineName
   End If

   If Trim$(p_strComputerName) = vbNullString Then
      MsgBox "You must select a computer from the list before clicking [Execute]"
      Exit Sub
   End If
   
   p_strComments = m_astrDescriptions(Me.lstComputers.ListIndex)
   
   p_vntRtn = m_objApiClass.GetWorkstationInfo(p_strComputerName)
   
   If IsEmpty(p_vntRtn) = False Then
      Me.lstMachineInfo.AddItem "Platform ID: " & p_vntRtn(5)
      Me.lstMachineInfo.AddItem "Workstation Comments: " & p_strComments
   End If
   
   Screen.MousePointer = vbHourglass
   
   Set p_objWmiInfo = New cWmiInfo
   p_vntRtn = p_objWmiInfo.GetWmiInfo(p_strComputerName)
      
   For p_lngLoop = 0 To UBound(p_vntRtn, 2)
      Me.lstMachineInfo.AddItem p_vntRtn(0, p_lngLoop) & ": " & _
                                p_vntRtn(1, p_lngLoop)
   Next p_lngLoop
   
   Screen.MousePointer = vbNormal
   
Exit Sub
ErrTrap:
   MsgBox p_strText3 & p_strComputerName & vbCrLf & _
          "Error Number: " & Err.Number & vbCrLf & _
          "Error: " & Err.Description
   Screen.MousePointer = vbNormal
End Sub

Private Sub UpdateList(ByVal xi_strDomainName As String)
   Dim p_avntRtn                       As Variant
   Dim p_lngLoop                       As Long
   Dim p_lngCount                      As Long
   Dim p_strLocalMachineName           As String
   
   p_avntRtn = m_objApiClass.GetServers()
   
   Me.lstComputers.Clear
   Me.lstComputers.AddItem "[Local Computer]"
   
   If IsEmpty(p_avntRtn) = False Then
      ReDim m_astrDescriptions(0 To UBound(p_avntRtn)) As String
      p_lngCount = 0
      For p_lngLoop = 0 To UBound(p_avntRtn)
         If Trim$(UCase$(p_avntRtn(p_lngLoop, 1))) = m_strLocalMachineName Then
            m_astrDescriptions(0) = p_avntRtn(p_lngLoop, 2)
            p_lngCount = p_lngCount + 1
         ElseIf Trim$(UCase$(p_avntRtn(p_lngLoop, 1))) <> m_strLocalMachineName Then
            Me.lstComputers.AddItem p_avntRtn(p_lngLoop, 1)
            m_astrDescriptions(p_lngCount) = p_avntRtn(p_lngLoop, 2)
            p_lngCount = p_lngCount + 1
         End If
      Next p_lngLoop
   End If
   
End Sub

Private Sub cmdPrint_Click()
   Dim p_lngLoop                       As Long
   Dim p_strTmp                        As String
   
   If Printer.DriverName = vbNullString Then
      MsgBox "No default printer available"
      Exit Sub
   End If

On Error Resume Next
   Printer.Copies = 1
   Printer.FontSize = 18
   Printer.Print ""
   Printer.CurrentY = Printer.CurrentY + 600
   Printer.CurrentX = Printer.CurrentX + 2000
   Printer.Print ""
   Printer.CurrentX = Printer.CurrentX + 4000
   Printer.Print "Information for Computer, " & Me.lstComputers.List(Me.lstComputers.ListIndex)
   Printer.Print ""
   Printer.Print ""
   
   Printer.FontSize = 12
   For p_lngLoop = 0 To Me.lstMachineInfo.ListCount - 1
      Printer.CurrentX = Printer.CurrentX + 1000
      
      p_strTmp = Me.lstMachineInfo.List(p_lngLoop)
      If Left$(p_strTmp, 1) = vbTab Then
         p_strTmp = vbTab & p_strTmp
      End If
      
      Printer.Print p_strTmp
      
      If Printer.CurrentY >= Printer.ScaleHeight - 600 Then
         Printer.NewPage
         Printer.CurrentY = Printer.CurrentY + 600
         Printer.Print ""
      End If
   Next

   Printer.EndDoc

End Sub

Private Sub cmdSave_Click()
   Dim p_lngFileNum                    As Long
   Dim p_lngLoop                       As Long
   
   Me.CommonDialog1.CancelError = True
   Me.CommonDialog1.DefaultExt = "TXT"
   Me.CommonDialog1.DialogTitle = "Save Computer Information"
   Me.CommonDialog1.FileName = "C:\" & Trim$(Me.lstComputers.List(Me.lstComputers.ListIndex)) & ".TXT"
   Me.CommonDialog1.Filter = "Text (*.txt)|*.txt"
   Me.CommonDialog1.FilterIndex = 1
   Me.CommonDialog1.Flags = cdlOFNExplorer Or cdlOFNLongNames Or _
                            cdlOFNNoReadOnlyReturn Or cdlOFNOverwritePrompt Or _
                            cdlOFNPathMustExist
   Me.CommonDialog1.InitDir = "C:\"
   
On Error Resume Next
   Me.CommonDialog1.ShowSave
   If Err.Number = cdlCancel Then
      ' User cancelled
      Exit Sub
   
   ElseIf Err.Number <> 0 Then
      MsgBox "Error: " & Err.Description & vbCrLf & _
             "Error Number: " & Err.Number & vbCrLf & _
             "Error Source: " & Err.Source, _
             vbOKOnly + vbExclamation, _
             "Error with File Save"
      Exit Sub
   
   Else
      p_lngFileNum = FreeFile
      Open Me.CommonDialog1.FileName For Output As #p_lngFileNum
      For p_lngLoop = 0 To Me.lstMachineInfo.ListCount - 1
         Print #p_lngFileNum, Me.lstMachineInfo.List(p_lngLoop)
      Next
      Close #p_lngFileNum
   End If

End Sub

Private Sub Form_Load()
   Dim p_strDomain                     As String
   Dim p_vntRtn                        As Variant
   
   Set m_objApiClass = New clsAPI

   m_strLocalMachineName = m_objApiClass.GetLocalMachineName()
   
   p_vntRtn = m_objApiClass.GetWorkstationInfo(m_strLocalMachineName)
   If IsEmpty(p_vntRtn) = False Then
      p_strDomain = p_vntRtn(6)
   End If
   
   Me.lblLogonDomain.Caption = p_strDomain
   
   UpdateList Me.lblLogonDomain.Caption
   
   Me.lstComputers.ListIndex = -1
   
End Sub

Private Sub lstComputers_Click()
   Dim p_vntRtn                        As Variant
   Dim p_strVer                        As String
   Dim p_strName                       As String
   Dim p_strComments                   As String
   
   Screen.MousePointer = vbHourglass
   
   If Me.lstComputers.ListIndex = -1 Then
      Exit Sub
   End If
   
   Screen.MousePointer = vbNormal
   
End Sub

Private Sub lstComputers_DblClick()
   cmdExecute_Click
End Sub
